function NB()
load('dataN.mat');
X_orig = x;
Y_orig = y;

numprocess=200;
train_sub = [0.01 0.1 0.25 0.50 0.75 1];

accuracy_nb = zeros (numprocess,length(train_sub));
precision_nb = zeros (numprocess,length(train_sub));
tp_nb = zeros (numprocess,length(train_sub));
tn_nb = zeros (numprocess,length(train_sub));
fp_nb = zeros (numprocess,length(train_sub));
fn_nb = zeros (numprocess,length(train_sub));
time = zeros (numprocess,length(train_sub));

for process=1:numprocess

    perm_mat = randperm(size(X_orig,1));

    X_train = zeros(size(X_orig,1) * 2 /3, size(X_orig,2));
    Y_train = zeros(size(Y_orig,1) * 2 /3, size(Y_orig,2));
    for i=1:(size(X_orig,1) * 2 /3)
        X_train(i,:) = X_orig(perm_mat(i),:);
        Y_train(i,:) = Y_orig(perm_mat(i),:);
    end

    X_test = zeros(size(X_orig,1) * 1 /3, size(X_orig,2));
    Y_test = zeros(size(Y_orig,1) * 1 /3, size(Y_orig,2));

    j=1;
    for i=(size(X_orig,1) * 2 /3 + 1):(size(X_orig,1))
        X_test(j,:) = X_orig(perm_mat(i),:);
        Y_test(j,:) = Y_orig(perm_mat(i),:);
        j = j + 1;
    end
    
    X_test_NB = X_test;
    matone = repmat(1,length(X_test),1);
    X_test = [matone X_test]; % add 1 to the X matrix to simplify calculations


    for a=1:length(train_sub)
        tic
        ts = train_sub(a).*length(X_train);
        X = zeros(ts, size(X_orig,2));
        Y = zeros(ts, size(Y_orig,2));
        X(1:ts,:) = X_train(1:ts,:);
        Y(1:ts,:) = Y_train(1:ts,:);

         % Naive Bayes
        [PXGC0 PXGC1 PRC0 PRC1] = NBLikelihood(X,Y);

        tp = 0;
        tn = 0;
        fp = 0;
        fn = 0;
        error_count = 0;
        for i=1:length(X_test_NB)
            pc0 = 0; % Probability that x_i is in C0
            pc1 = 0; % Probability that x_i is in C1
            for j=1:size(X_test_NB,2)
                pc0 = pc0 + PXGC0(X_test_NB(i,j),j);
                pc1 = pc1 + PXGC1(X_test_NB(i,j),j);
            end    
            if (pc1 >= pc0 && Y_test(i) == 1)
                 tp = tp + 1;
            elseif (pc0 > pc1 && Y_test(i) == 0)
                 tn = tn + 1;
            elseif (pc1 >= pc0 && Y_test(i) == 0)
                 error_count = error_count + 1;
                 fp = fp + 1;
            elseif (pc0 > pc1 && Y_test(i) == 1)
                 error_count = error_count + 1;
                 fn = fn + 1;
            end
        end
        accuracy_nb(process,a) = (tp + tn) / length(X_test_NB );
        if (tp + fp > 0)
            precision_nb(process,a) = tp / (tp + fp);
        else
            precision_nb(process,a) = 0;
        end
        tp_nb(process,a) = tp / length(X_test_NB );
        tn_nb(process,a) = tn / length(X_test_NB );
        fp_nb(process,a) = fp / length(X_test_NB );
        fn_nb(process,a) = fn / length(X_test_NB );
        time(process,a) = toc;
    end
end

a_nb = mean(accuracy_nb)
p_nb= mean(precision_nb)
tpos_nb = mean(tp_nb)
tneg_nb = mean(tn_nb)
fpos_nb = mean(fp_nb)
fneg_nb = mean(fn_nb)
time_nb = mean(time)
save('nb.mat','time_nb', 'train_sub','a_nb','p_nb','tpos_nb','tneg_nb','fpos_nb','fneg_nb')

end
