function NNbackprop()


load('data.mat');
X_orig = x;
Y_orig = y;

numprocess=200;
% Fractions of training set
train_sub = [0.01 0.1 0.25 0.50 0.75 1];

accuracy_nt = zeros (numprocess,length(train_sub));
precision_nt = zeros (numprocess,length(train_sub));
tp_nt = zeros (numprocess,length(train_sub));
tn_nt = zeros (numprocess,length(train_sub));
fp_nt = zeros (numprocess,length(train_sub));
fn_nt = zeros (numprocess,length(train_sub));
time = zeros (numprocess,length(train_sub));

maxepoch = 3000;
numhid = 4;
epsilon=0.003;

for process=1:numprocess

    perm_mat = randperm(size(X_orig,1));

    X_train_all = zeros(size(X_orig,1) * 2 /3, size(X_orig,2));
    T_train_all = zeros(size(Y_orig,1) * 2 /3, size(Y_orig,2));
    for i=1:(size(X_orig,1) * 2 /3)
        X_train_all(i,:) = X_orig(perm_mat(i),:);
        T_train_all(i,:) = Y_orig(perm_mat(i),:);
    end

    testdata = zeros(size(X_orig,1) * 1 /3, size(X_orig,2));
    testtargets = zeros(size(Y_orig,1) * 1 /3, size(Y_orig,2));

    j=1;
    for i=(size(X_orig,1) * 2 /3 + 1):(size(X_orig,1))
        testdata(j,:) = X_orig(perm_mat(i),:);
        testtargets(j,:) = Y_orig(perm_mat(i),:);
        j = j + 1;
    end
    
    for a=1:length(train_sub)
        tic
        ts = int32(train_sub(a).*length(X_train_all));
        data = zeros(ts, size(X_train_all,2));
        targets = zeros(ts, size(T_train_all,2));
        
        data(1:ts,:) = X_train_all(1:ts,:);
        targets(1:ts,:) = T_train_all(1:ts,:);

        initialweightsize = .01;

        numcases = size(data,1);
        numin    = size(data,2); 
        numout   = size(targets,2);
        tiny=exp(-200);

        epoch=1; 
        inhid = initialweightsize*randn(numin, numhid); 
        hidout = initialweightsize*randn(numhid, numout); 
        hidbiases = initialweightsize*randn(1, numhid); 
        outbiases = initialweightsize*randn(1, numout); 
      
        for epoch=epoch:maxepoch

            hidsum = data*inhid + repmat(hidbiases, numcases, 1);
            hidacts = 1./(1+exp(-hidsum));
            outsum = hidacts*hidout + repmat(outbiases, numcases, 1);
            unnormalisedoutputs = exp(outsum);
            rowsums=sum(unnormalisedoutputs,2);
            outputs=unnormalisedoutputs./repmat(rowsums,1,numout);

            residuals = outputs-targets;
            dEbydoutsum = residuals;
            E = - sum(sum(targets.*log(tiny+outputs)));

            dEbydhidacts = dEbydoutsum*(hidout');
            dEbydhidsum = dEbydhidacts.*hidacts.*(1-hidacts);
            dEbydoutbiases = sum(dEbydoutsum); 
            dEbydhidout = hidacts'*dEbydoutsum; 
            dEbydhidbiases = sum(dEbydhidsum); 
            dEbydinhid  = data'*dEbydhidsum; 

            inhid     = inhid - epsilon*dEbydinhid;
            hidout    = hidout - epsilon*dEbydhidout;
            hidbiases = hidbiases - epsilon*dEbydhidbiases;
            outbiases = outbiases - epsilon*dEbydoutbiases;

        end;
        
        [tnumcases numin] = size(testdata); 
        numout   = size(testtargets,2);

        thidsum = testdata*inhid + repmat(hidbiases, tnumcases, 1);
        thidacts = 1./(1+exp(-thidsum));
        toutsum = thidacts*hidout + repmat(outbiases, tnumcases, 1);
        tunnormalisedoutputs = exp(toutsum);
        trowsums=sum(tunnormalisedoutputs,2);
        toutputs=tunnormalisedoutputs./repmat(trowsums,1,numout);
  
        error_count = 0;
        tp = 0;
        tn = 0;
        fp = 0;
        fn = 0;
        testguesses = (toutputs - repmat( (max(toutputs'))', 1, numout)) >= 0;
        for i=1:size(testtargets,1) 
            if (testguesses(i,1) == testtargets(i,1) && testguesses(i,2) == testtargets(i,2))
                if(testtargets(i,1) == 1)
                 tp = tp + 1;
                else
                 tn = tn + 1;
                end
            else
                if(testtargets(i,1) == 1)
                    fn = fn + 1;
                    error_count = error_count + 1;
                else
                    fp = fp + 1;
                    error_count = error_count + 1;
                end

            end
        end

        accuracy_nt(process,a) = (tp + tn) / size(testtargets,1);
        if (tp + fp > 0)
            precision_nt(process,a) = tp / (tp + fp);
        else
            precision_nt(process,a) = 0;
        end
        tp_nt(process,a) = tp / size(testtargets,1);
        tn_nt(process,a) = tn / size(testtargets,1);
        fp_nt(process,a) = fp / size(testtargets,1);
        fn_nt(process,a) = fn / size(testtargets,1);
        time(process,a) = toc;


    end
end

a_nt = mean(accuracy_nt)
p_nt= mean(precision_nt)
tpos_nt = mean(tp_nt)
tneg_nt = mean(tn_nt)
fpos_nt = mean(fp_nt)
fneg_nt = mean(fn_nt)
time_nt = mean(time)
save('nt.mat','time_nt', 'train_sub','a_nt','p_nt','tpos_nt','tneg_nt','fpos_nt','fneg_nt')

return
end
