#!/usr/bin/python

# This file generates the matlab readable features and label data from python feature dictionary.

import sys
import getopt
from features import *

def main(argv):

    num_skypes = 0
    num_flows = 0
    try:
      fvec = open('x.m', 'w')
      outvec = open('y.m', 'w')
    except Exception as e:
      print "Error creating the matlab files"
      usage()
      return False
    fvec.write('% client avg interarrival time - client std interarrival time - client max interarrival time - client min interarrival time\n% server avg interarrival time - server std interarrival time - server max interarrival time - server min interarrival time\n% client avg packet size - client std packet size - client max packet size - client min packet size\n% server avg packet size - server std packet size - server max packet size - server min packet size\n')
    fvec.write('x = [\n')
    outvec.write('y= [\n')
    feature = features[0]
    for feature in features:
      if (feature['num packets'] > 3):
        num_flows += 1
        fvec.write(str(feature['flow duration'])+','+ \
          str(feature['client avg interarrival time'])+','+str(feature['client std interarrival time'])+','+str(feature['client max interarrival time'])+','+str(feature['client min interarrival time'])+','+\
          str(feature['server avg interarrival time'])+','+str(feature['server std interarrival time'])+','+str(feature['server max interarrival time'])+','+str(feature['server min interarrival time'])+','+\
          str(feature['client avg packet size'])+','+str(feature['client std packet size'])+','+str(feature['client max packet size'])+','+str(feature['client min packet size'])+','+\
          str(feature['server avg packet size'])+','+str(feature['server std packet size'])+','+str(feature['server max packet size'])+','+str(feature['server min packet size'])\
          + ';\n')

        if (feature['appname'] == "skype"):
          outvec.write(str(1) + ';\n')
          num_skypes += 1
        else:
          outvec.write(str(0) + ';\n')

    fvec.write('\n];\n')
    outvec.write('\n];\n')

    print "Number of Skype flows:"+str(num_skypes)+"Number of Valid flows:"+str(num_flows)

def usage():
    print "Usage: python ft_python_to_matlab.py"
    print

if __name__ == "__main__":
    main(sys.argv[1:])
