#!/bin/bash

# This script loops and captures the packets every 10 minutes
# After 10 minutes it will kill the network packet capture script
# and generates the pcap files.
# At the last step the pcap files are send to another script which extracts the
# feature set and store it in Matlab readable format
echo "Starting script"
sudo -k

WAITTIME=600
CUR_DIR="`pwd -P`"
USER="`whoami`"

while [ 1 ]
do

DATE_STR="`date +'%Y%m%d%k%M%S' | sed -e "s/ /0/g"`"
TCPLOG="${CUR_DIR}/script.$DATE_STR.pcap"
PYPKL="${CUR_DIR}/script.$DATE_STR.pkl"
TCPLOG_TEXT="${CUR_DIR}/script.$DATE_STR.txt"

echo "Start port/IP capture using netstat"

sudo $CUR_DIR/nt_srv.sh "$PYPKL" &
NTSRV_PID="$!"


echo
echo "Start capturing the packets in here $TCPLOG"

echo sudo tcpdump  -s 1500 -n  -w  \"$TCPLOG\"
sudo tcpdump -n -w "$TCPLOG"  &

TCPDUMP_PID1="$!"

if [ "$TCPDUMP_PID1" == "" ]
then
	echo "tcpdump did not run."
	continue	
fi

sleep $WAITTIME
echo

echo "Killing TCPDUMP with PID=$TCPDUMP_PID1"
echo "============================"
echo "TCPDUMP Statistics"
sudo kill -2 $TCPDUMP_PID1
echo "Killing NTSRV with PID=$NTSRV_PID"
echo "============================"
sudo kill -9 $NTSRV_PID 2>&1 > /dev/null
sleep 1
echo "============================"

sudo chmod ugo+rw netstat.py
sudo chmod ugo+rw "$TCPLOG"
sudo chmod ugo+rw "$PYPKL"
done

python flow_capture.py -f "$TCPLOG" -p "$PYPKL"
sudo rm -f netstat.out netstat.bkup tmp.out
