#!/usr/bin/python

# This file generates netstat pickle from the python.

import sys
import pickle
import getopt
from netstat import *

def main(argv):

    output = ""

    try:
      opts, args = getopt.getopt(argv, "hp:", ["help", "pklfile="])
    except(getopt.GetoptError):
      usage()
      sys.exit(2)

    for opt, arg in opts:
      if opt in ("-h", "--help"):
        usage()
        sys.exit()

      if opt in ("-p"):
        pklfile = arg

    try:
      pkl_file = open(pklfile, 'w+')
    except Exception as e:
      print "Please Provide the pickle file"
      usage()
      return False

    # Pickle dictionary using protocol 0.
    pickle.dump(appflowmap, pkl_file)

    pkl_file.close()

    try:
      pkl_file = open(pklfile + "2", 'w+')
    except Exception as e:
      print "Please Provide the pickle file"
      usage()
      return False

    # Pickle dictionary using protocol 0.
    pickle.dump(inet_addr, pkl_file)

    pkl_file.close()

def usage():
    print "Usage: python nt_srv.py -p [Pickle File]"
    print

if __name__ == "__main__":
    main(sys.argv[1:])
