#!/bin/bash

echo "Starting netstat mapping"
CUR_DIR="`pwd -P`"
USER="`whoami`"
FNAME="$1"

if [ "$FNAME" == "" ]
then
    echo "Please provide the file name for the Python Pickle"
    exit
fi

INETADDR="`ifconfig | grep 'inet addr' |  sed -e 's/  */ /g'| cut -f 2-3 -d ' ' | cut -f 2 -d ':'|tr '\n' "," | sed -e "s/,/\',\'/g"`"

rm -f netstat.out netstat.bkup
touch netstat.out

#echo "#(appname, protocol, src, src_port, dst, dst_port, date)"> tmp.out

while [ 1 ]
do
	
	rm -f tmp.out
	cp netstat.out tmp2.out
	echo "#(appname, protocol, src, src_port, dst, dst_port)"> tmp.out

	APP_PORTS_STATS="`netstat -a --inet --program  --numeric-ports | grep 'tcp\|udp'|  sed -e 's/  */;/g'  `"
	echo "=========================" >> netstat.bkup
	echo "`date` - `date "+%s.%N"`" >> netstat.bkup
	echo "$APP_PORTS_STATS" >> netstat.bkup
	echo "=========================" >> netstat.bkup

	for APP in $APP_PORTS_STATS
	do
		PROTOCOL="`echo $APP | cut -f 1 -d ';'`"
	#	echo "$PROTOCOL"
		SRC="`echo $APP | cut -f 4 -d ';' | cut -f 1 -d ':'`"
	#	echo "$SRC"
		SRC_PORT="`echo $APP | cut -f 4 -d ';' | cut -f 2 -d ':'`"
	#	echo "$SRC_PORT"
		DST="`echo $APP | cut -f 5 -d ';' | cut -f 1 -d ':'`"
	#	echo "$DST"
		DST_PORT="`echo $APP | cut -f 5 -d ';' | cut -f 2 -d ':'`"
	#	echo "$DST_PORT"
		STATUS="`echo $APP | cut -f 6 -d ';' `"
	#	echo "$STATUS"
		APPNAME="`echo $APP | cut -f 7 -d ';' | cut -f 2 -d '/'`"
		if [ "$APPNAME" = "" -o   "$APPNAME" = "r" ]
		then
			APPNAME="`echo $STATUS| cut -f 2 -d '/'`"
			STATUS=""
		fi

		if [ "$APPNAME" = "-" ]
		then
			continue
		fi

                if [ "$DST_PORT" = "*" ]
                then
                        DST_PORT="0"
                fi

                if [ "$SRC_PORT" = "*" ]
                then
                        SRC_PORT="0"
                fi

		echo "{'appname':'$APPNAME', 'protocol':'$PROTOCOL' ,'src':'$SRC' ,'src_port':$SRC_PORT ,'dst':'$DST' ,'dst_port':$DST_PORT }," >> tmp.out #, `date "+%s.%N"` )" >> tmp.out
	done

	cat tmp.out tmp2.out | sort | uniq > netstat.out
	echo "appflowmap = [" > netstat.py
	cat netstat.out >> netstat.py
	echo "]" >> netstat.py
        echo "inet_addr=['$INETADDR']" >> netstat.py
        python nt_srv.py -p "$FNAME"
	#date "+%s.%N"
	#sleep 0.5

done



